#include "MenuSpline.h"  // inclut windows.h
#include <math.h>
#include <stdio.h>
#include "resource.h"
#include "trajuseq.h" /* pour define ou undefine ORTHOQ */

/* EXPORTS */
HWND hwndTraj ;
int flcont = CONT_C2 ;  /* Pour traces precision dans testspline */

/* Procdures externes */
void ini_testspline(void) ;
void fin_prog(void) ;
void set_continuite (int) ;
void set_ck1N1( double ck1N1) ;
void set_cliss( double cliss) ;
void set_muc( double cmuc) ;
void set_mode2 (int) ;
void set_mode3 (int) ;
void set_moden (int) ;
void deplace (double x, double y) ;
void precision (double x, double y) ;
int droite (double x, double y) ;
int cercle (double x, double y) ;
#ifdef ORTHOQ 
int orthodrom (double x, double y) ;
#endif
int supprime (double *x, double *y) ;
int entete (double x, double y) ;
int ajoute (double x, double y) ;
void tracespline(HDC hdc) ;
int selelem (double *x, double *y) ;
int proxsom (double *x, double *y) ;
int insere (double *x, double *y) ;
void firstseg(int) ;
void lastseg(int) ;
void tangini (double x, double y) ;
void tangfin (double x, double y) ;
void misajour(void) ;

/* Procdures internes */
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL CALLBACK SelModesCont(HWND hwndDlg, UINT message, WPARAM wParam,
						   LPARAM lParam)  ;
/* Common local */
BOOL CALLBACK ProcAide(HWND hwndHlp, UINT message, WPARAM wParam,
						   LPARAM lParam)  ;
HINSTANCE hinst ;
HWND hwndHlp, hwndC3, hScroll1, hScroll2, hT1, hT2, hV1, hV2 ;
static char MonAppli[] = "TestTtraj" ;
static char TexteAide[] =
"\r\n    Avec les boutons de la souris :\r\n\r\n" 
"Ctrl+      DROITE : ajoute un point en queue\r\n"
"     Shift+DROITE : insere un point\r\n"
"Ctrl+Shift+DROITE : ajoute un point en tte\r\n"
"           GAUCHE : dplace un point, une tgte\r\n"
"     Shift+GAUCHE : modifie la prcision au point\r\n"
"Ctrl+Shift+GAUCHE : supprime un point\r\n"
"\r\n"
"En continuit C3, les rgles suivantes interviennent :\r\n"
"\r\n"
"2 segments isols sont traits en standard en degr 5-6\r\n"
"ou 6-5.\r\n"
"Si l'option \"Cf. N-segm.\" est coche ils sont traits\r\n"
"en 6-6 avec minimisation.\r\n"
"\r\n"
"3 segments isols sont traits en standard en degr\r\n"
"4-5-6, 5-5-5 ou 6-4-5\r\n"
"Si l'option \"Cf. N-segm.\" est coche ils sont traits\r\n"
"en 6-6-6 ou en 6-5-6 avec minimisation.\r\n"
"\r\n"
"Mme quand elles sont coches, les options 5minC, 5minL\r\n"
"ou 5minL-C sont remplaces par 6-5-6minC, 6-5-6minL ou\r\n"
"6-5-6minL-C s'il n'y a que 3 segments, ou bien par\r\n"
"6-6-6minC, 6-6-6minL ou 6-6-6minL-C s'il n'y a que 2.\r\n"
"\r\n"
"Mme quand elles sont coches, les options 6-5-6minC,\r\n"
"6-5-6minL ou 6-5-6minL-C sont remplaces par 6-6-6minC,\r\n"
"6-6-6minL ou 6-6-6minL-C s'il n'y a que 2 segments.\r\n"
"\r\n"
"En mode N-segments degr 65..6C et 65..6L un curseur\r\n"
"not C1N1 permet de faire varier la pondration de la\r\n"
"minimisation de courbure ou longueur pour les 1er et\r\n"
"et dernier segments (de degr 6).\r\n"
"\r\n"
"Dans les 3 derniers modes (N-segments minimisation L-C)\r\n"
"un curseur not Cmuc permet de faire varier la pondra-\r\n"
"tion de miminimisation de courbure relativement  celle\r\n"
"de longueur.\r\n"
"\r\n"
"En mode lissage, un curseur supplmentaire not Cliss\r\n"
"permet de faire varier la pondration du lissage.\r\n"
 ;


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
MSG 		msg ;
WNDCLASSEX	wndclass ;

    hinst = hInstance ;

	wndclass.cbSize			= sizeof (wndclass) ;
	wndclass.style			= CS_HREDRAW | CS_VREDRAW ;
	wndclass.lpfnWndProc	= WndProc ;
	wndclass.cbClsExtra		= 0 ;
	wndclass.cbWndExtra		= 0 ;
	wndclass.hInstance		= hInstance ;
	wndclass.hIcon			= LoadIcon (NULL, IDI_APPLICATION) ;
	wndclass.hCursor		= LoadCursor (NULL, IDC_ARROW) ;
	wndclass.hbrBackground	= (HBRUSH) GetStockObject (WHITE_BRUSH) ;
	wndclass.lpszMenuName	= "MenuSpline" ;
	wndclass.lpszClassName	= MonAppli ;
    wndclass.hIconSm        = LoadIcon (NULL, IDI_APPLICATION) ;

	RegisterClassEx (&wndclass) ;

	hwndTraj = CreateWindow (MonAppli, "Test trajectoires polynomiales",
                         WS_OVERLAPPEDWINDOW,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         NULL, NULL, hInstance, NULL) ;

	ShowWindow (hwndTraj, iCmdShow) ;
	UpdateWindow (hwndTraj) ;

	while (GetMessage (&msg, NULL, 0, 0))
	{
		if (!IsDialogMessage(hwndC3, &msg))
		{
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
	}

	return msg.wParam ;
}

static LOGFONT logfont ;
static HFONT hFont ;

static int moden = IDC_P6MLCC3 ;
static double ck1N1 = 1., cmuc = 0.5, cliss, cliss2 = 0.5, cliss3 = 0.5 ;
static int ix1n1, ixmuc, ixliss ;
#define IXRANGE 32000
const int ixrange = IXRANGE ;
const double rinf = 1.e-4 ;
const double rsup = 1.e+4 ;
const double kaef = IXRANGE/(4.-(-4.)) ;



LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LONG lParam)
{
double x,y ;
POINT pt ;
int nok ;
static int code = 0 ;

static HENHMETAFILE hEmf = 0 ; /* Pour menu COPIER */
static HMENU hMenu ;
HDC	         hdc, hdcbis  ;
PAINTSTRUCT  ps ;

	switch (iMsg)
	{
	case WM_CREATE :
		ini_testspline() ;

		/* Mise en place de la coche sur 
					le mode de continuit-lissage slectionn */
		hMenu = GetMenu(hwnd) ;

		CheckMenuItem(hMenu, CONT_C2, MF_BYCOMMAND |
			    (flcont == CONT_C2 ? MF_CHECKED : MF_UNCHECKED)) ; 

		CheckMenuItem(hMenu, CONT_C2LISS, MF_BYCOMMAND |  
				(flcont == CONT_C2LISS ? MF_CHECKED : MF_UNCHECKED)) ; 

		CheckMenuItem(hMenu, CONT_C3, MF_BYCOMMAND |  
				(flcont == CONT_C3 ? MF_CHECKED : MF_UNCHECKED)) ; 

		CheckMenuItem(hMenu, CONT_C3LISS, MF_BYCOMMAND |  
				(flcont == CONT_C3LISS ? MF_CHECKED : MF_UNCHECKED)) ; 

		/* Cration fentre dialogue pour choix modes de calculs */

		hwndC3 = CreateDialog(hinst, MAKEINTRESOURCE(IDD_MODECONT), (HWND) NULL, 
			(DLGPROC)SelModesCont) ;

		ShowWindow (hwndC3, SW_SHOW) ;

		return 0 ;

	case WM_COMMAND :
		code = LOWORD(wParam) ;
		nok = 1 ; /* pour modification texte fentre dialogue */
		switch (code)
		{
		/* On modifie le texte de la fentre de dialogue en fonction du
		                    mode de continuit-lissage slectionn */
		case CONT_C2 :
			SetWindowText(hwndC3, "Fentre inoprante en continuit C2");
			nok = 0 ;
		case CONT_C2LISS :
			if(nok)	SetWindowText(hwndC3, "Lissage en C2 par dernier ascenseur");
			nok = 0 ;
		case CONT_C3 :
			if(nok)	SetWindowText(hwndC3, "Tous modes oprants en continuit C3");
			nok = 0 ;
		case CONT_C3LISS :
			if(nok)	SetWindowText(hwndC3, "Seuls 3 derniers modes oprants en lissage C3");

			/* On coche le menu slectionn */
			CheckMenuItem(hMenu, flcont, MF_BYCOMMAND | MF_UNCHECKED) ; 
			flcont = code ;
			CheckMenuItem(hMenu, flcont, MF_BYCOMMAND | MF_CHECKED) ; 

			set_continuite(flcont-CONT_C2) ;
			set_ck1N1 (ck1N1) ;
			cliss = flcont < CONT_C3 ? cliss2 : cliss3 ;
			ixliss = (int) floor(ixrange*cliss+0.5) ;
			ixliss = ixliss < ixrange ? ixliss : ixrange ;
			ixliss = ixliss > 0 ? ixliss : 0 ;
			set_cliss (cliss) ;
			set_muc (cmuc) ;
			/* si lissage C3, on force un des 3 derniers modes */
			if (flcont == CONT_C3LISS && (moden < IDC_P6MLCC3 || moden > IDC_P656MLCC3)) 
			{
				moden = IDC_P6MLCC3 ;
				CheckRadioButton (hwndC3, IDC_D6445, IDC_P656MLCC3, moden) ;
			}

			/* On fait traiter suivant le moden en cours */
			if (flcont >= CONT_C3)
			    SendMessage(hwndC3, WM_COMMAND, MAKELONG(moden,0), (LPARAM) 0L) ;
			else
			{
				if (flcont == CONT_C2LISS)
			       SendMessage(hwndC3, WM_COMMAND, MAKELONG(SHOWC2LISS,0), (LPARAM) 0L) ;
				misajour () ;
				InvalidateRect (hwnd, NULL, TRUE) ; 
			}
			return 0 ;
		case TANGTINI:
		case CRNULINI :
		case NDFICINI :
			firstseg(code) ;
			misajour() ;
			InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
		case TANGTFIN :
		case CRNULFIN :
		case NDFICFIN :
			lastseg(code) ;
			misajour () ;
			InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;

		case FINI:
			SendMessage(hwnd,WM_CLOSE,0,0L);
			return 0 ;

		case ID_COPIER :
		    if (hEmf) { DeleteEnhMetaFile(hEmf) ; hEmf = 0 ; }
            hdcbis = CreateEnhMetaFile (NULL, NULL, NULL, NULL) ;
            tracespline(hdcbis) ;
			hEmf = CloseEnhMetaFile (hdcbis) ;
		    OpenClipboard (hwnd) ;
		    EmptyClipboard () ;
			SetClipboardData (CF_ENHMETAFILE, hEmf) ;
		    CloseClipboard() ;
			return 0 ;

        case AIDE :
			if (!IsWindow(hwndHlp))
			{
				hwndHlp = CreateWindow("edit", NULL, 
					WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_SIZEBOX |
					WS_VSCROLL |
					WS_BORDER | ES_LEFT | ES_MULTILINE | ES_READONLY,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         400, 200,
					NULL, NULL, hinst, NULL) ;
				GetObject(GetStockObject(ANSI_FIXED_FONT), sizeof(LOGFONT), 
					(PSTR) &logfont) ;
				hFont = CreateFontIndirect(&logfont);
				SendMessage(hwndHlp, WM_SETFONT, (WPARAM) hFont, 0) ;
				SetWindowText (hwndHlp, TexteAide ) ;
			}
			else
				ShowWindow(hwndHlp, SW_RESTORE) ;
			    SetFocus(hwndHlp) ;
            return 0 ;
		}
        return 0 ;

	case WM_RBUTTONDOWN :
		x = LOWORD (lParam) ;
		y = HIWORD(lParam) ;
		if ((GetKeyState(VK_CONTROL)<0) && (GetKeyState(VK_SHIFT)<0))
		{
			/* CTRL+SHIFT+DROIT -> Ajoute point en tte */
			entete(x, y) ;
			nok = 0 ;
		}
		else if (wParam & MK_CONTROL) 
		{
			/* CTRL+DROIT -> Ajoute point en queue */
			ajoute(x,y) ;
			nok = 0 ;
		}
		else if(wParam & MK_SHIFT)
		{
			/* SHIFT+DROIT -> Insere point sur courbe */
			nok = insere(&x,&y) ;
		}
		else
		{
			/* DROIT -> Neant */
			nok = 1 ;
		}
		if (nok)
		{
		   PlaySound("c:\\windows\\S_error.wav", NULL ,SND_FILENAME | SND_ASYNC) ;
		   code = 0 ;
		}
		else  
		{
			pt.x = (LONG) x ; pt.y = (LONG) y ;
			ClientToScreen(hwnd, &pt) ;
			SetCursorPos(pt.x, pt.y) ;
			InvalidateRect (hwnd, NULL, TRUE) ; 
		}
		return 0 ;

	case WM_LBUTTONDOWN :
		x = LOWORD (lParam) ;
		y = HIWORD(lParam) ;
		switch (code)
		{
		case ARC_DROITE :
            nok = droite(x, y) ;
			if (nok)
			   PlaySound("c:\\windows\\S_error.wav", NULL ,SND_FILENAME | SND_ASYNC) ;
			else InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
		case ARC_CERCLE :
			nok = cercle(x,y) ;
			if (nok)
			   PlaySound("c:\\windows\\S_error.wav", NULL ,SND_FILENAME | SND_ASYNC) ;
			else InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
#ifdef ORTHOQ
		case ARC_ORTHO :
			nok = orthodrom(x,y) ;
			if (nok)
			   PlaySound("c:\\windows\\S_error.wav", NULL ,SND_FILENAME | SND_ASYNC) ;
			else InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
#endif
		default :
			if ((GetKeyState(VK_CONTROL)<0) && (GetKeyState(VK_SHIFT)<0))
			{
				/* CTRL+SHIFT+GAUCHE -> Suppression du point */
				nok = supprime(&x,&y) ;
			}
			else if (wParam & MK_CONTROL) 
			{
				nok = 1 ;
			}
			else if(wParam & MK_SHIFT)
			{
				if (flcont == CONT_C2LISS || flcont == CONT_C3LISS)
				{
				/* SHIFT+GAUCHE -> Modification prcision du point */
			        if (selelem(&x, &y) == 2)
					{
						code = PRECISION ;
						nok = 0 ;
						break ;
					}
					else nok = 1 ;
				}
				else nok = 1 ;
			}
			else
			{
				/* GAUCHE -> selon selelem : modifie tgte ini (1) point (2) ou tgte fin (3)  */
				nok = 0 ;
			    code = selelem(&x, &y) ;
				switch (code)
				{
				case 1 :
					code = MOVEINI ;
					firstseg (TANGTINI) ;
					break ;
				case 2 :
				    code = DEPLACE ; 
					break ;
				case 3 :
					code = MOVEFIN ;
					lastseg (TANGTFIN) ;
					break ;
				default :
					code = 0 ;
					nok = 1 ;
					break ;
				}
			}
			if (nok)
			{
			   PlaySound("c:\\windows\\S_error.wav", NULL ,SND_FILENAME | SND_ASYNC) ;
			   code = 0 ;
			}
			else  
			{
				pt.x = (LONG) x ; pt.y = (LONG) y ;
				ClientToScreen(hwnd, &pt) ;
				SetCursorPos(pt.x, pt.y) ;
			    InvalidateRect (hwnd, NULL, TRUE) ; 
			}
			return 0 ;
		}
		break ;

	case WM_MOUSEMOVE :
		x = LOWORD (lParam) ;
		y = HIWORD(lParam) ;
		switch (code)
		{
		case MOVEINI :
			tangini(x,y) ;
		    InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
		case MOVEFIN :
			tangfin(x,y) ;
		    InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
		case DEPLACE :
		    deplace(x,y) ;
		    InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
		case PRECISION :
			precision(x,y) ;
		    InvalidateRect (hwnd, NULL, TRUE) ; 
			return 0 ;
		}
		break ;

	case WM_RBUTTONUP :
	case WM_LBUTTONUP :
		code = 0 ;
		return 0 ;

	case WM_PAINT :
		hdc = BeginPaint (hwnd, &ps) ;
        tracespline(hdc) ;
		EndPaint (hwnd, &ps) ;
		return 0 ;

	case WM_DESTROY :
		DeleteEnhMetaFile(hEmf) ;
		PostQuitMessage (0) ;
		fin_prog() ;
		return 0 ;
	}
	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}

BOOL CALLBACK SelModesCont(HWND hDlg, UINT message, WPARAM wParam,
						   LPARAM lParam) 
{ 
int ix, iy, mode ;
char text[10] ;

    switch (message) { 
		case WM_INITDIALOG :
		{
			ix = 1 ; set_mode2(ix) ; ix += IDC_MODEN2 ;
			CheckRadioButton (hDlg, IDC_MODEN2, IDC_DEG65, ix) ;

			iy = 2 ; set_mode3(iy) ; iy += IDC_MODEN3 ;
			CheckRadioButton (hDlg, IDC_MODEN3, IDC_DEG645, iy) ;

			set_moden(moden-IDC_D6445) ;
			CheckRadioButton (hDlg, IDC_D6445, IDC_P656MLCC3, moden) ;

        /* Fixe etat ascenseur valeur ck1N1 ou muc */

			hScroll1 = GetDlgItem (hDlg, IDC_SCROLLBAR1) ;
			hT1 = GetDlgItem (hDlg, IDC_TXT_CK1N1) ;
			hV1 = GetDlgItem (hDlg, IDC_AFI_CK1N1) ;

			SetScrollRange (hScroll1, SB_CTL, 0, ixrange, FALSE) ;
			ix1n1 = (int) floor(kaef*log10(ck1N1/rinf)) ;
			ix1n1 = ix1n1 < ixrange ? ix1n1 : ixrange ;
			ix1n1 = ix1n1 > 0 ? ix1n1 : 0 ;

			ixmuc = (int) floor(ixrange*cmuc+0.5) ;
			ixmuc = ixmuc < ixrange ? ixmuc : ixrange ;
			ixmuc = ixmuc > 0 ? ixmuc : 0 ;

			ix = moden == IDC_D656C || moden == IDC_P656MLC3 ;
			iy = moden >= IDC_P6MLCC3 && moden <= IDC_P656MLCC3 ;

			if (ix || iy)
			{
				SetScrollPos (hScroll1, SB_CTL, ix ? ix1n1 : ixmuc, TRUE) ;
				sprintf( text, "%.4lf", ix ? ck1N1 : cmuc) ;
				SetDlgItemText (hDlg, IDC_AFI_CK1N1, text) ;
				SetDlgItemText (hDlg, IDC_TXT_CK1N1, ix ? "C1N1" : "Cmuc") ;
                ShowWindow (hScroll1, SW_SHOW) ;
				ShowWindow (hT1, SW_SHOW) ;
				ShowWindow (hV1, SW_SHOW) ;
			}
			else
			{
                ShowWindow (hScroll1,SW_HIDE) ;
				ShowWindow (hT1,SW_HIDE) ;
				ShowWindow (hV1,SW_HIDE) ;
			}
			
			hScroll2 = GetDlgItem (hDlg, IDC_SCROLLBAR2) ;
			hT2 = GetDlgItem (hDlg, IDC_TXT_CLISS) ;
			hV2 = GetDlgItem (hDlg, IDC_AFI_CLISS) ;

			SetScrollRange (hScroll2, SB_CTL, 0, ixrange, FALSE) ;
            
			cliss = flcont < CONT_C3 ? cliss2 : cliss3 ;
			ixliss = (int) floor(ixrange*cliss+0.5) ;
			ixliss = ixliss < ixrange ? ixliss : ixrange ;
			ixliss = ixliss > 0 ? ixliss : 0 ;

			if (flcont == CONT_C2LISS || flcont == CONT_C3LISS)
			{
				SetScrollPos (hScroll2, SB_CTL, ixliss, TRUE) ;
				sprintf( text, "%.4lf", cliss) ;
				SetDlgItemText (hDlg, IDC_AFI_CLISS, text) ;
                ShowWindow (hScroll2, SW_SHOW) ;
				ShowWindow (hT2, SW_SHOW) ;
				ShowWindow (hV2, SW_SHOW) ;
			}
			else
			{
                ShowWindow (hScroll2,SW_HIDE) ;
				ShowWindow (hT2,SW_HIDE) ;
				ShowWindow (hV2,SW_HIDE) ;
			}
			
			return FALSE ;
		}

        case WM_COMMAND :
			mode = LOWORD(wParam) ;
            switch (mode) 
			{ 
			    case IDC_MODEN2 :
				case IDC_DEG56 :
				case IDC_DEG65 :
					set_mode2 (mode - IDC_MODEN2) ;
					if(flcont < CONT_C3) /* Passage en continuit C3 */
					{
			SendMessage(hwndTraj, WM_COMMAND, MAKELONG(flcont+2,0), (LPARAM) 0L) ;
						break ;
					}
					misajour() ;
					InvalidateRect (hwndTraj, NULL, TRUE) ; 
					return TRUE ;
				case IDC_MODEN3 :
				case IDC_DEG546 :
				case IDC_DEG555 :
				case IDC_DEG645 :
					set_mode3 (mode - IDC_MODEN3) ;
					if(flcont < CONT_C3) /* Passage en continuit C3 */
					{
			SendMessage(hwndTraj, WM_COMMAND, MAKELONG(flcont+2,0), (LPARAM) 0L) ;
						break ;
					}
					misajour() ;
					InvalidateRect (hwndTraj, NULL, TRUE) ; 
					return TRUE ;
				case IDC_D6445 :
				case IDC_D5446 :
				case IDC_D666C :
				case IDC_D5555C :
				case IDC_D656C :
				case IDC_P6MLC3 :
				case IDC_P5MLC3 :
				case IDC_P656MLC3 :
				case IDC_P6MLCC3 :
				case IDC_P5MLCC3 :
				case IDC_P656MLCC3 :
					moden = mode ;
					if(mode < IDC_P6MLCC3 && flcont == CONT_C3LISS)
					{
			SendMessage(hwndTraj, WM_COMMAND, MAKELONG(CONT_C3,0), (LPARAM) 0L) ;
						break ;
					}

					if(flcont < CONT_C3) /* Passage en continuit C3 */
					{
			SendMessage(hwndTraj, WM_COMMAND, MAKELONG(flcont+2,0), (LPARAM) 0L) ;
						break ;
					}

					ix = (moden == IDC_D656C || moden == IDC_P656MLC3) ;
					iy = (moden >= IDC_P6MLCC3 && moden <= IDC_P656MLCC3) ;

					if (ix || iy)
					{
						SetScrollPos (hScroll1, SB_CTL, ix ? ix1n1 : ixmuc, TRUE) ;
						sprintf( text, "%.4lf", ix ? ck1N1 : cmuc) ;
						SetDlgItemText (hDlg, IDC_AFI_CK1N1, text) ;
						SetDlgItemText (hDlg, IDC_TXT_CK1N1, ix ? "C1N1" : "Cmuc") ;
						ShowWindow (hScroll1, SW_SHOW) ;
						ShowWindow (hT1, SW_SHOW) ;
						ShowWindow (hV1, SW_SHOW) ;
					}
					else
					{
						ShowWindow (hScroll1,SW_HIDE) ;
						ShowWindow (hT1,SW_HIDE) ;
						ShowWindow (hV1,SW_HIDE) ;
					}

					if (flcont == CONT_C2LISS || flcont == CONT_C3LISS)
					{
						SetScrollPos (hScroll2, SB_CTL, ixliss, TRUE) ;
						sprintf( text, "%.4lf", cliss) ;
						SetDlgItemText (hDlg, IDC_AFI_CLISS, text) ;
						ShowWindow (hScroll2, SW_SHOW) ;
						ShowWindow (hT2, SW_SHOW) ;
						ShowWindow (hV2, SW_SHOW) ;
					}
					else
					{
						ShowWindow (hScroll2,SW_HIDE) ;
						ShowWindow (hT2,SW_HIDE) ;
						ShowWindow (hV2,SW_HIDE) ;
					}
			
					set_moden (moden - IDC_D6445) ;
					misajour() ;
					InvalidateRect (hwndTraj, NULL, TRUE) ; 
					return TRUE ;
				case SHOWC2LISS :
					SetScrollPos (hScroll2, SB_CTL, ixliss, TRUE) ;
					sprintf( text, "%.4lf", cliss) ;
					SetDlgItemText (hDlg, IDC_AFI_CLISS, text) ;
					ShowWindow (hScroll2, SW_SHOW) ;
					ShowWindow (hT2, SW_SHOW) ;
					ShowWindow (hV2, SW_SHOW) ;
					return TRUE ;
            } 
			break ;


	case WM_VSCROLL :
		{
			ix = -1 ;
			if ((HWND) lParam == hScroll1)
			{
				if (moden == IDC_D656C || moden == IDC_P656MLC3) 
					ix = ix1n1 ;
				else if (moden >= IDC_P6MLCC3 && moden <= IDC_P656MLCC3) 
					ix = ixmuc ;
			}
			else if ((HWND) lParam == hScroll2) ix = ixliss ;
			if (ix < 0) return FALSE ;
			switch (LOWORD(wParam))
			{
			case SB_PAGEDOWN : 
				ix += ixrange/20 ;
				break ;
			case SB_LINEDOWN :
				++ix ;
				break ;
			case SB_PAGEUP : 
				ix -= ixrange/20 ;
				break ;
			case SB_LINEUP :
				--ix ;
				break ;
			case SB_TOP :
				ix = 0 ;
				break ;
			case SB_BOTTOM :
				ix = ixrange ;
				break ;
			case SB_THUMBPOSITION :
			case SB_THUMBTRACK :
				ix = HIWORD (wParam) ;
				break ;
			default :
				return FALSE ;
			}

			ix = ix < ixrange ? ix : ixrange ;
			ix = ix > 0 ? ix : 0 ;

			if ((HWND) lParam == hScroll1)
			{
				if (moden == IDC_D656C || moden == IDC_P656MLC3) 
				{
					if (ix != ix1n1)
					{
						ix1n1 = ix ;
						SetScrollPos (hScroll1, SB_CTL, ix1n1, TRUE) ;
						ck1N1 = rinf*pow (10., ix/kaef) ;
						sprintf( text, "%.4lf", ck1N1) ;
						SetDlgItemText (hDlg, IDC_AFI_CK1N1, text) ;
						set_ck1N1(ck1N1) ;
						misajour() ;
						InvalidateRect (hwndTraj, NULL, TRUE) ; 
					}
				}
				else if (moden >= IDC_P6MLCC3 && moden <= IDC_P656MLCC3)
				{
					if (ix != ixmuc)
					{
						ixmuc = ix ;
						SetScrollPos (hScroll1, SB_CTL, ixmuc, TRUE) ;
						cmuc = (double)ixmuc/ixrange ;
						sprintf( text, "%.4lf", cmuc) ;
						SetDlgItemText (hDlg, IDC_AFI_CK1N1, text) ;
						set_muc(cmuc) ;
						misajour() ;
						InvalidateRect (hwndTraj, NULL, TRUE) ; 
					}
				}
			}
			else if ((HWND) lParam == hScroll2)
			{
				if (ix != ixliss)
				{
					ixliss = ix ;
					SetScrollPos (hScroll2, SB_CTL, ixliss, TRUE) ;
					cliss = (double)ixliss/ixrange ;
					if (flcont < CONT_C3) cliss2 = cliss ; 
					else cliss3 = cliss ; 
					sprintf( text, "%.4lf", cliss) ;
					SetDlgItemText (hDlg, IDC_AFI_CLISS, text) ;
					set_cliss(cliss) ;
					misajour() ;
					InvalidateRect (hwndTraj, NULL, TRUE) ; 
				}
			}

			return TRUE ;
		}
	}

    return FALSE; 
} 
